#include <iostream>
#include <cstdio>
#include <vector>
#include <utility>
#include <cstring>
#include <cstdlib>

using namespace std;

enum { FL_T=0, FL_W=8, FL_A=9 };
enum {XXX=5};

typedef pair<int, int> ii;
typedef vector<ii> vii;

bool flags[10];

int y;

bool leap(int y)
{
    if(y%400 == 0)
        return true;
    if(y%100 == 0)
        return false;
    if(y%4 == 0)
        return true;
    return false;
}

int conv(int d, int m)
{
    static const int days[13]={0,31,28,31,30,31,30,31,31,30,31,30,31};

    int r = d-1;
    for(int i=1; i<m; ++i)
        r += days[i];
    if(m>2 && leap(y))
        r++;
    return r;
}

int daysy;

int days(int y)
{
    int r=0;
    for(int i=0; i<y; ++i)
        r += 365 + leap(i);
    return r;
}

vii v;

void process(char *s)
{
    int d1,d2,m1,m2;
    if(strchr(s, '-')) {
        sscanf(s, "%d.%d.-%d.%d.", &d1, &m1, &d2, &m2);
    } else {
        sscanf(s, "%d.%d.", &d1, &m1);
        d2=d1; m2=m1;
    }
    if(leap(y)) {
        if(d1==29 && m1==2)
            d1=1, m1=3;
        if(d2==29 && m2==2)
            d2=28;
    }
    d1=conv(d1,m1);
    d2=conv(d2,m2);
    v.push_back(ii(d1,d2));
}

int paschal(int y)
{
    int golden, solar, lunar, p;

    golden = (y%19)+1;
    solar = (y-1600)/100 - (y-1600)/400;
    lunar = (((y-1400)/100)*8)/25;
    p = (3003 - (11*golden) + solar - lunar) %30;
    if(p==29 || (p==28 && golden>11)) p--;

    p = 31+28+leap(y)+p + 1;
    int w = XXX + daysy + p;
    w %= 7;
    return p + 6-w;
}

bool iswork(int d, int w)
{
    bool r = false;
    if((w+d)%7 < 5)
        r = true;
    if(d==0 || d==paschal(y) || d==conv(1,5) || d==conv(8,5)
            || d==conv(5,7) || d==conv(6,7) || d==conv(28,9)
            || d==conv(28,10) || d==conv(17,11) || d==conv(24,12)
            || d==conv(25,12) || d==conv(26, 12))
        r = false;

    return r;
}

bool isholy(int d, int w)
{
    bool r = false;
    if((w+d)%7 == 6)
        r = true;

    if(d==0 || d==paschal(y) || d==conv(1,5) || d==conv(8,5)
            || d==conv(5,7) || d==conv(6,7) || d==conv(28,9)
            || d==conv(28,10) || d==conv(17,11) || d==conv(24,12)
            || d==conv(25,12) || d==conv(26, 12))
        r = true;
    return r;
}

bool is_a(int d, int w)
{
    if(not iswork(d,w))
        return false;
    for(;;) {
        --d;
        if(iswork(d,w))
            return false;
        if(isholy(d,w))
            return true;
    }
}

int main()
{
    string s;
    char t[10000];
    while(cin >> s >> t >> y) {
        daysy = days(y);
        flags[FL_T] = strchr(s.c_str(), 't') != NULL;
        flags[FL_W] = strchr(s.c_str(), 'w') != NULL;
        flags[FL_A] = strchr(s.c_str(), 'a') != NULL;
        for(int i=1; i<=7; ++i)
            flags[i] = strchr(s.c_str(), '0'+i) != NULL;

        cin >> s >> t >> y;
        v.clear();

        char *tt=t-1;
        while(tt) {
            ++tt;
            char *e=strchr(tt, ',');
            if(e) *e=0;
            process(tt);
            tt=e;
        }

        int count = 0;
        for(unsigned i=0; i<v.size(); ++i) {
            int w = XXX + daysy;
            for(int j=v[i].first; j<=v[i].second; ++j) {
                bool ok=false;
                if(flags[(w+j)%7 + 1])
                        ok=true;
                if(flags[FL_W] && iswork(j,w))
                    ok=true;
                if(flags[FL_T] && isholy(j,w))
                    ok=true;
                if(flags[FL_A] && is_a(j,w))
                    ok=true;

                if(ok)
                    count ++;
            }
        }

        cout << count << endl;

    }

    return 0;
}
